# -*- coding: utf-8 -*-
"""
 TP C10.2 - Micromoteur WEBRA
 """

## Bibliothèques
import numpy as np
import matplotlib.pyplot as pl

## Constantes et Paramètres
# On indique le nom du fichier. A adapter en fonction du nom que vous avez
# donné à votre fichier de résultat Solidworks
FichierSldW="Micromoteur.txt"

# Les constantes du problème
L=40.25/1000 # longueur de la bielle en m
R=11.5/1000 # longueur de l'excentrique en m

# Création de la liste des Theta pour l'étude analytique
# Prenons 90 valeurs entre 0 et 2*pi, on utilise la fonction linspace de numpy
""" Compléter cette ligne """
# Rmq : on pourrait prendre la liste des theta issue de Solidworks

# Initialisation de la liste des x pour l'étude analytique
XAnalytique=[]

## FONCTIONS
#On crée une fonction pour l'importation des données Solidworks
def donneesSldW(NomFichier):
    #initialisation des listes locales liste_theta et liste_x
    liste_theta=[]
    liste_x=[]
    with open(NomFichier,'r') as fichier:
        # on lit les 3 lignes d'entête sans rien en faire
        for i in range(3):
            fichier.readline()
        # on enregistre les valeurs des colonnes dans deux listes
        for ligne in fichier :
            theta,x=ligne.rstrip('\n').split()
            liste_theta.append(float(theta))
            liste_x.append(float(x))
    return liste_theta,liste_x

# On crée une fonction correspondant à l'étude analytique
def CalculPosition(theta):
    """ Compléter cette ligne """
    return x

""" PROGRAMME PRINCIPAL """
# Récupération des données Solidworks
ThetaSldw,XSldw=donneesSldW(FichierSldW)

# Calcul Analytique
# on utilise ici des listes ce qui impose une boucle sur les valeurs de theta
""" Compléter ces lignes """
""" Compléter ces lignes """

#Tracé des courbes
pl.grid()
pl.xlabel(r"$\theta$ angle de l'entrée en radians")
pl.ylabel(r"$x$ déplacement du piston en m")
pl.plot(ThetaSldw,XSldw, label="SolidWorks")
# pl.plot(ThetaAnalytique,XAnalytique, label="Analytique")
pl.legend()
pl.show()